Index: lib/rtl/dbgbuffer.c
===================================================================
--- lib/rtl/dbgbuffer.c	(revision 21808)
+++ lib/rtl/dbgbuffer.c	(working copy)
@@ -16,18 +16,18 @@
 /*
  * @unimplemented
  */
-PRTL_DEBUG_BUFFER NTAPI
+PRTL_DEBUG_INFORMATION NTAPI
 RtlCreateQueryDebugBuffer(IN ULONG Size,
                           IN BOOLEAN EventPair)
 {
    NTSTATUS Status;
-   PRTL_DEBUG_BUFFER Buf = NULL;
-   SIZE_T SectionSize = 100 * PAGE_SIZE;
+   PRTL_DEBUG_INFORMATION Buf = NULL;
+   SIZE_T ViewSize = 100 * PAGE_SIZE;
 
    Status = NtAllocateVirtualMemory( NtCurrentProcess(),
                                     (PVOID*)&Buf,
                                      0,
-                                     &SectionSize,
+                                     &ViewSize,
                                      MEM_COMMIT,
                                      PAGE_READWRITE);
    if (!NT_SUCCESS(Status))
@@ -35,10 +35,10 @@
         return NULL;
      }
 
-   Buf->SectionBase = Buf;
-   Buf->SectionSize = SectionSize;
+   Buf->ViewBaseClient = Buf;
+   Buf->ViewSize = ViewSize;
 
-   DPRINT("RtlCQDB: BA: %p BS: 0x%lx\n", Buf->SectionBase, Buf->SectionSize);
+   DPRINT("RtlCQDB: BA: %p BS: 0x%lx\n", Buf->ViewBaseClient, Buf->ViewSize);
 
    return Buf;
 }
@@ -47,7 +47,7 @@
  * @unimplemented
  */
 NTSTATUS NTAPI
-RtlDestroyQueryDebugBuffer(IN PRTL_DEBUG_BUFFER Buf)
+RtlDestroyQueryDebugBuffer(IN PRTL_DEBUG_INFORMATION Buf)
 {
    NTSTATUS Status = STATUS_SUCCESS;
 
@@ -55,7 +55,7 @@
      {
      Status = NtFreeVirtualMemory( NtCurrentProcess(),
                                   (PVOID)&Buf,
-                                  &Buf->SectionSize,
+                                  &Buf->ViewSize,
                                    MEM_RELEASE);
      }
    if (!NT_SUCCESS(Status))
@@ -71,7 +71,7 @@
  */
 NTSTATUS NTAPI
 RtlpQueryRemoteProcessModules(HANDLE ProcessHandle,
-                              IN PRTL_PROCESS_MODULES ModuleInformation OPTIONAL,
+                              IN PRTL_PROCESS_MODULES Modules OPTIONAL,
                               IN ULONG Size OPTIONAL,
                               OUT PULONG ReturnedSize)
 {
@@ -103,14 +103,14 @@
        return Status;
     }
 
-  if (ModuleInformation == NULL || Size == 0)
+  if (Modules == NULL || Size == 0)
     {
       Status = STATUS_INFO_LENGTH_MISMATCH;
     }
   else
     {
-      ModuleInformation->ModuleCount = 0;
-      ModulePtr = &ModuleInformation->ModuleEntry[0];
+      Modules->NumberOfModules = 0;
+      ModulePtr = &Modules->Modules[0];
       Status = STATUS_SUCCESS;
     }
 
@@ -154,7 +154,7 @@
 
    /* read the current module */
    Status = NtReadVirtualMemory ( ProcessHandle,
-            CONTAINING_RECORD(pleCurEntry, LDR_DATA_TABLE_ENTRY, InLoadOrderModuleList),
+            CONTAINING_RECORD(pleCurEntry, LDR_DATA_TABLE_ENTRY, InLoadOrderLinks),
                                  &lmModule,
                                  sizeof(LDR_DATA_TABLE_ENTRY),
                                  NULL );
@@ -183,36 +183,37 @@
         {
           Status = STATUS_INFO_LENGTH_MISMATCH;
         }
-      else if (ModuleInformation != NULL)
+      else if (Modules != NULL)
         {
-          ModulePtr->Reserved[0] = ModulePtr->Reserved[1] = 0;      // FIXME: ??
-          ModulePtr->Base        = lmModule.DllBase;
-          ModulePtr->Size        = lmModule.SizeOfImage;
+          ModulePtr->Section = 0;
+          ModulePtr->MappedBase = NULL;      // FIXME: ??
+          ModulePtr->ImageBase        = lmModule.DllBase;
+          ModulePtr->ImageSize        = lmModule.SizeOfImage;
           ModulePtr->Flags       = lmModule.Flags;
-          ModulePtr->Index       = 0;      // FIXME:  ??
-          ModulePtr->Unknown     = 0;      // FIXME: ??
+          ModulePtr->LoadOrderIndex       = 0;      // FIXME:  ??
+          ModulePtr->InitOrderIndex     = 0;      // FIXME: ??
           ModulePtr->LoadCount   = lmModule.LoadCount;
 
           AnsiString.Length        = 0;
           AnsiString.MaximumLength = 256;
-          AnsiString.Buffer        = ModulePtr->ImageName;
+          AnsiString.Buffer        = ModulePtr->FullPathName;
           RtlUnicodeStringToAnsiString(&AnsiString,
                                        &Unicode,
                                        FALSE);
 
-          p = strrchr(ModulePtr->ImageName, '\\');
+          p = strrchr(ModulePtr->FullPathName, '\\');
           if (p != NULL)
-            ModulePtr->ModuleNameOffset = p - ModulePtr->ImageName + 1;
+            ModulePtr->OffsetToFileName = p - ModulePtr->FullPathName + 1;
           else
-            ModulePtr->ModuleNameOffset = 0;
+            ModulePtr->OffsetToFileName = 0;
 
           ModulePtr++;
-          ModuleInformation->ModuleCount++;
+          Modules->NumberOfModules++;
         }
       UsedSize += sizeof(RTL_PROCESS_MODULE_INFORMATION);
 
       /* address of the next module in the list */
-      pleCurEntry = lmModule.InLoadOrderModuleList.Flink;
+      pleCurEntry = lmModule.InLoadOrderLinks.Flink;
   }
 
   if (ReturnedSize != 0)
@@ -230,13 +231,13 @@
 NTSTATUS NTAPI
 RtlQueryProcessDebugInformation(IN ULONG ProcessId,
                                 IN ULONG DebugInfoMask,
-                                IN OUT PRTL_DEBUG_BUFFER Buf)
+                                IN OUT PRTL_DEBUG_INFORMATION Buf)
 {
    NTSTATUS Status = STATUS_SUCCESS;
    ULONG Pid = (ULONG) NtCurrentTeb()->Cid.UniqueProcess;
 
-   Buf->InfoClassMask = DebugInfoMask;
-   Buf->SizeOfInfo = sizeof(RTL_DEBUG_BUFFER);
+   Buf->Flags = DebugInfoMask;
+   Buf->OffsetFree = sizeof(RTL_DEBUG_INFORMATION);
 
    DPRINT("QueryProcessDebugInformation Start\n");
 
@@ -258,7 +259,7 @@
     ULONG ReturnSize = 0;
     ULONG MSize;
 
-    Mp = (PRTL_PROCESS_MODULES)(Buf + Buf->SizeOfInfo);
+    Mp = (PRTL_PROCESS_MODULES)(Buf + Buf->OffsetFree);
 
     /* I like this better than the do & while loop. */
     Status = LdrQueryProcessModuleInformation( NULL,
@@ -272,9 +273,9 @@
          return Status;
      }
 
-    MSize = Mp->ModuleCount * (sizeof(RTL_PROCESS_MODULES) + 8);
-    Buf->ModuleInformation = Mp;
-    Buf->SizeOfInfo = Buf->SizeOfInfo + MSize;
+    MSize = Mp->NumberOfModules * (sizeof(RTL_PROCESS_MODULES) + 8);
+    Buf->Modules = Mp;
+    Buf->OffsetFree = Buf->OffsetFree + MSize;
      }
 
    if (DebugInfoMask & RTL_DEBUG_QUERY_HEAPS)
@@ -282,7 +283,7 @@
    PRTL_PROCESS_HEAPS Hp;
    ULONG HSize;
 
-   Hp = (PRTL_PROCESS_HEAPS)(Buf + Buf->SizeOfInfo);
+   Hp = (PRTL_PROCESS_HEAPS)(Buf + Buf->OffsetFree);
    HSize = sizeof(RTL_PROCESS_HEAPS);
         if (DebugInfoMask & RTL_DEBUG_QUERY_HEAP_TAGS)
           {
@@ -290,8 +291,8 @@
         if (DebugInfoMask & RTL_DEBUG_QUERY_HEAP_BLOCKS)
           {
           }
-   Buf->HeapInformation = Hp;
-   Buf->SizeOfInfo = Buf->SizeOfInfo + HSize;
+   Buf->Heaps = Hp;
+   Buf->OffsetFree = Buf->OffsetFree + HSize;
 
      }
 
@@ -300,14 +301,14 @@
    PRTL_PROCESS_LOCKS Lp;
    ULONG LSize;
 
-   Lp = (PRTL_PROCESS_LOCKS)(Buf + Buf->SizeOfInfo);
+   Lp = (PRTL_PROCESS_LOCKS)(Buf + Buf->OffsetFree);
    LSize = sizeof(RTL_PROCESS_LOCKS);
-   Buf->LockInformation = Lp;
-   Buf->SizeOfInfo = Buf->SizeOfInfo + LSize;
+   Buf->Locks = Lp;
+   Buf->OffsetFree = Buf->OffsetFree + LSize;
     }
 
    DPRINT("QueryProcessDebugInformation end \n");
-   DPRINT("QueryDebugInfo : 0x%lx\n", Buf->SizeOfInfo);
+   DPRINT("QueryDebugInfo : 0x%lx\n", Buf->OffsetFree);
 }
 else
 {
@@ -315,7 +316,7 @@
   CLIENT_ID ClientId;
   OBJECT_ATTRIBUTES ObjectAttributes;
 
-       Buf->Unknown[0] = (ULONG)NtCurrentProcess();
+       Buf->TargetProcessHandle = NtCurrentProcess();
 
        ClientId.UniqueThread = 0;
        ClientId.UniqueProcess = (HANDLE)ProcessId;
@@ -340,7 +341,7 @@
     ULONG ReturnSize = 0;
     ULONG MSize;
 
-    Mp = (PRTL_PROCESS_MODULES)(Buf + Buf->SizeOfInfo);
+    Mp = (PRTL_PROCESS_MODULES)(Buf + Buf->OffsetFree);
 
     Status = RtlpQueryRemoteProcessModules( hProcess,
                                             NULL,
@@ -356,9 +357,9 @@
          return Status;
      }
 
-    MSize = Mp->ModuleCount * (sizeof(RTL_PROCESS_MODULES) + 8);
-    Buf->ModuleInformation = Mp;
-    Buf->SizeOfInfo = Buf->SizeOfInfo + MSize;
+    MSize = Mp->NumberOfModules * (sizeof(RTL_PROCESS_MODULES) + 8);
+    Buf->Modules = Mp;
+    Buf->OffsetFree = Buf->OffsetFree + MSize;
      }
 
    if (DebugInfoMask & RTL_DEBUG_QUERY_HEAPS)
@@ -366,7 +367,7 @@
    PRTL_PROCESS_HEAPS Hp;
    ULONG HSize;
 
-   Hp = (PRTL_PROCESS_HEAPS)(Buf + Buf->SizeOfInfo);
+   Hp = (PRTL_PROCESS_HEAPS)(Buf + Buf->OffsetFree);
    HSize = sizeof(RTL_PROCESS_HEAPS);
         if (DebugInfoMask & RTL_DEBUG_QUERY_HEAP_TAGS)
           {
@@ -374,8 +375,8 @@
         if (DebugInfoMask & RTL_DEBUG_QUERY_HEAP_BLOCKS)
           {
           }
-   Buf->HeapInformation = Hp;
-   Buf->SizeOfInfo = Buf->SizeOfInfo + HSize;
+   Buf->Heaps = Hp;
+   Buf->OffsetFree = Buf->OffsetFree + HSize;
 
      }
 
@@ -384,14 +385,14 @@
    PRTL_PROCESS_LOCKS Lp;
    ULONG LSize;
 
-   Lp = (PRTL_PROCESS_LOCKS)(Buf + Buf->SizeOfInfo);
+   Lp = (PRTL_PROCESS_LOCKS)(Buf + Buf->OffsetFree);
    LSize = sizeof(RTL_PROCESS_LOCKS);
-   Buf->LockInformation = Lp;
-   Buf->SizeOfInfo = Buf->SizeOfInfo + LSize;
+   Buf->Locks = Lp;
+   Buf->OffsetFree = Buf->OffsetFree + LSize;
     }
 
    DPRINT("QueryProcessDebugInformation end \n");
-   DPRINT("QueryDebugInfo : 0x%lx\n", Buf->SizeOfInfo);
+   DPRINT("QueryDebugInfo : 0x%lx\n", Buf->OffsetFree);
 }
    return Status;
 
Index: lib/rtl/debug.c
===================================================================
--- lib/rtl/debug.c	(revision 21808)
+++ lib/rtl/debug.c	(working copy)
@@ -272,7 +272,7 @@
 NTAPI
 DbgPrompt(PCH OutputString,
           PCH InputString,
-          USHORT InputSize)
+          ULONG InputSize)
 {
     ANSI_STRING Output;
     ANSI_STRING Input;
Index: lib/rtl/network.c
===================================================================
--- lib/rtl/network.c	(revision 21808)
+++ lib/rtl/network.c	(working copy)
@@ -1,8 +1,8 @@
 /*
  * COPYRIGHT:         See COPYING in the top level directory
- * PROJECT:           ReactOS system libraries
+ * PROJECT:           ReactOS Runtime Library
  * PURPOSE:           Network Address Translation implementation
- * PROGRAMMER:        
+ * PROGRAMMER:        Alex Ionescu (alexi@tinykrnl.org)
  */
 
 /* INCLUDES *****************************************************************/
@@ -14,110 +14,74 @@
 
 /* FUNCTIONS ***************************************************************/
 
-/* Borrow this from some headers... */
-typedef struct
-{
-  union
-  {
-    struct { UCHAR s_b1,s_b2,s_b3,s_b4; } S_un_b;
-    struct { USHORT s_w1,s_w2; } S_un_w;
-    ULONG S_addr;
-  } S_un;
-} in_addr;
-
-typedef struct
-{
-  union
-  {
-    UCHAR _S6_u8[16];
-    USHORT _S6_u16[8];
-    ULONG _S6_u32[4];
-  } S6_un;
-} in6_addr;
-
-
 /*
-* @implemented
-*/
+ * @implemented
+ */
 LPSTR
 NTAPI
-RtlIpv4AddressToStringA(
-	PULONG IP,
-	LPSTR Buffer
-	)
+RtlIpv4AddressToStringA(IN struct in_addr *Addr,
+                        OUT PCHAR S)
 {
-  in_addr addr;
-  addr.S_un.S_addr = *IP;
-  return Buffer + sprintf(Buffer, "%u.%u.%u.%u", addr.S_un.S_un_b.s_b1,
-                                                 addr.S_un.S_un_b.s_b2,
-                                                 addr.S_un.S_un_b.s_b3,
-                                                 addr.S_un.S_un_b.s_b4);
+    return S + sprintf(S, "%u.%u.%u.%u", Addr->S_un.S_un_b.s_b1,
+                                         Addr->S_un.S_un_b.s_b2,
+                                         Addr->S_un.S_un_b.s_b3,
+                                         Addr->S_un.S_un_b.s_b4);
 }
 
 /*
-* @unimplemented
-*/
+ * @unimplemented
+ */
 NTSTATUS
 NTAPI
-RtlIpv4AddressToStringExA(
-	PULONG IP,
-	PULONG Port,
-	LPSTR Buffer,
-	PULONG MaxSize
-	)
+RtlIpv4AddressToStringExA(IN struct in_addr *Address,
+                          IN USHORT Port,
+                          OUT PCHAR AddressString,
+                          IN OUT PULONG AddressStringLength)
 {
-	UNIMPLEMENTED;
-	return STATUS_NOT_IMPLEMENTED;
+    UNIMPLEMENTED;
+    return STATUS_NOT_IMPLEMENTED;
 }
 
 /*
-* @implemented
-*/
+ * @implemented
+ */
 LPWSTR
 NTAPI
-RtlIpv4AddressToStringW(
-	PULONG IP,
-	LPWSTR Buffer
-	)
+RtlIpv4AddressToStringW(IN struct in_addr *Addr,
+                        OUT PWCHAR S)
 {
-  in_addr addr;
-  addr.S_un.S_addr = *IP;
-  return Buffer + swprintf(Buffer, L"%u.%u.%u.%u", addr.S_un.S_un_b.s_b1,
-                                                   addr.S_un.S_un_b.s_b2,
-                                                   addr.S_un.S_un_b.s_b3,
-                                                   addr.S_un.S_un_b.s_b4);
+    return S + swprintf(S, L"%u.%u.%u.%u", Addr->S_un.S_un_b.s_b1,
+                                           Addr->S_un.S_un_b.s_b2,
+                                           Addr->S_un.S_un_b.s_b3,
+                                           Addr->S_un.S_un_b.s_b4);
 }
 
 /*
-* @unimplemented
-*/
+ * @unimplemented
+ */
 NTSTATUS
 NTAPI
-RtlIpv4AddressToStringExW(
-	PULONG IP,
-	PULONG Port,
-	LPWSTR Buffer,
-	PULONG MaxSize
-	)
+RtlIpv4AddressToStringExW(IN struct in_addr *Address,
+                          IN USHORT Port,
+                          OUT PWCHAR AddressString,
+                          IN OUT PULONG AddressStringLength)
 {
-	UNIMPLEMENTED;
-	return STATUS_NOT_IMPLEMENTED;
+    UNIMPLEMENTED;
+    return STATUS_NOT_IMPLEMENTED;
 }
 
 /*
-* @unimplemented
-*/
+ * @unimplemented
+ */
 NTSTATUS
 NTAPI
-RtlIpv4StringToAddressA(
-	IN LPSTR IpString,
-	IN ULONG Base,
-	OUT PVOID PtrToIpAddr,
-	OUT ULONG IpAddr
-	)
+RtlIpv4StringToAddressA(IN PCHAR String,
+                        IN BOOLEAN Strict,
+                        OUT PCHAR *Terminator,
+                        OUT struct in_addr *Addr)
 {
-	UNIMPLEMENTED;
-	return STATUS_NOT_IMPLEMENTED;
+    UNIMPLEMENTED;
+    return STATUS_NOT_IMPLEMENTED;
 }
 
 /*
@@ -125,15 +89,13 @@
 */
 NTSTATUS
 NTAPI
-RtlIpv4StringToAddressExA(
-	IN LPSTR IpString,
-	IN ULONG Base,
-	OUT PULONG IpAddr,
-	OUT PULONG Port
-	)
+RtlIpv4StringToAddressExA(IN PCHAR AddressString,
+                          IN BOOLEAN Strict,
+                          OUT struct in_addr *Address,
+                          IN PUSHORT Port)
 {
-	UNIMPLEMENTED;
-	return STATUS_NOT_IMPLEMENTED;
+    UNIMPLEMENTED;
+    return STATUS_NOT_IMPLEMENTED;
 }
 
 /*
@@ -141,15 +103,13 @@
 */
 NTSTATUS
 NTAPI
-RtlIpv4StringToAddressW(
-	IN LPWSTR IpString,
-	IN ULONG Base,
-    OUT PULONG PtrToIpAddr,
-    OUT PULONG IpAddr
-	)
+RtlIpv4StringToAddressW(IN PWCHAR String,
+                        IN UCHAR Strict,
+                        OUT PWCHAR Terminator,
+                        OUT struct in_addr *Addr)
 {
-	UNIMPLEMENTED;
-	return STATUS_NOT_IMPLEMENTED;
+    UNIMPLEMENTED;
+    return STATUS_NOT_IMPLEMENTED;
 }
 
 /*
@@ -157,15 +117,13 @@
 */
 NTSTATUS
 NTAPI
-RtlIpv4StringToAddressExW(
-	IN LPWSTR IpString,
-	IN ULONG Base,
-	OUT PULONG IpAddr,
-	OUT PULONG Port
-	)
+RtlIpv4StringToAddressExW(IN PWCHAR AddressString,
+                          IN BOOLEAN Strict,
+                          OUT struct in_addr *Address,
+                          OUT PUSHORT Port)
 {
-	UNIMPLEMENTED;
-	return STATUS_NOT_IMPLEMENTED;
+    UNIMPLEMENTED;
+    return STATUS_NOT_IMPLEMENTED;
 }
 
 /*
@@ -173,13 +131,11 @@
 */
 NTSTATUS
 NTAPI
-RtlIpv6AddressToStringA(
-	PULONG IP,
-	LPSTR Buffer
-	)
+RtlIpv6AddressToStringA(IN struct in6_addr *Addr,
+                        OUT PCHAR S)
 {
-	UNIMPLEMENTED;
-	return STATUS_NOT_IMPLEMENTED;
+    UNIMPLEMENTED;
+    return STATUS_NOT_IMPLEMENTED;
 }
 
 /*
@@ -187,15 +143,14 @@
 */
 NTSTATUS
 NTAPI
-RtlIpv6AddressToStringExA(
-	PULONG IP,
-	PULONG Port,
-	LPSTR Buffer,
-	PULONG MaxSize
-	)
+RtlIpv6AddressToStringExA(IN struct in6_addr *Address,
+                          IN ULONG ScopeId,
+                          IN ULONG Port,
+                          OUT PCHAR AddressString,
+                          IN OUT PULONG AddressStringLength)
 {
-	UNIMPLEMENTED;
-	return STATUS_NOT_IMPLEMENTED;
+    UNIMPLEMENTED;
+    return STATUS_NOT_IMPLEMENTED;
 }
 
 /*
@@ -203,13 +158,11 @@
 */
 NTSTATUS
 NTAPI
-RtlIpv6AddressToStringW(
-	PULONG IP,
-	LPWSTR Buffer
-	)
+RtlIpv6AddressToStringW(IN struct in6_addr *Addr,
+                        OUT PWCHAR S)
 {
-	UNIMPLEMENTED;
-	return STATUS_NOT_IMPLEMENTED;
+    UNIMPLEMENTED;
+    return STATUS_NOT_IMPLEMENTED;
 }
 
 /*
@@ -217,15 +170,14 @@
 */
 NTSTATUS
 NTAPI
-RtlIpv6AddressToStringExW(
-	PULONG IP,
-	PULONG Port,
-	LPWSTR Buffer,
-	PULONG MaxSize
-	)
+RtlIpv6AddressToStringExW(IN struct in6_addr *Address,
+                          IN ULONG ScopeId,
+                          IN USHORT Port,
+                          IN OUT PWCHAR AddressString,
+                          IN OUT PULONG AddressStringLength)
 {
-	UNIMPLEMENTED;
-	return STATUS_NOT_IMPLEMENTED;
+    UNIMPLEMENTED;
+    return STATUS_NOT_IMPLEMENTED;
 }
 
 /*
@@ -233,9 +185,9 @@
 */
 NTSTATUS
 NTAPI
-RtlIpv6StringToAddressA(IN LPSTR Name,
-                        OUT PULONG Unknown,
-                        OUT PVOID IpAddr)
+RtlIpv6StringToAddressA(IN PCHAR Name,
+                        OUT PCHAR *Terminator,
+                        OUT struct in6_addr *Addr)
 {
     UNIMPLEMENTED;
     return STATUS_NOT_IMPLEMENTED;
@@ -246,10 +198,10 @@
 */
 NTSTATUS
 NTAPI
-RtlIpv6StringToAddressExA(IN LPSTR AddressName,
-                          IN PVOID Address,
-                          IN PULONG ScopeId,
-                          IN PUSHORT Port)
+RtlIpv6StringToAddressExA(IN PCHAR AddressString,
+                          OUT struct in6_addr *Address,
+                          OUT PULONG ScopeId,
+                          OUT PUSHORT Port)
 {
     UNIMPLEMENTED;
     return STATUS_NOT_IMPLEMENTED;
@@ -260,9 +212,9 @@
 */
 NTSTATUS
 NTAPI
-RtlIpv6StringToAddressW(IN LPWSTR Name,
-                        OUT PULONG Unknown,
-                        OUT PVOID IpAddr)
+RtlIpv6StringToAddressW(IN PWCHAR Name,
+                        OUT PCHAR *Terminator,
+                        OUT struct in6_addr *Addr)
 {
     UNIMPLEMENTED;
     return STATUS_NOT_IMPLEMENTED;
@@ -273,10 +225,10 @@
 */
 NTSTATUS
 NTAPI
-RtlIpv6StringToAddressExW(IN LPWSTR AddressName,
-                          IN PVOID Address,
-                          IN PULONG ScopeId,
-                          IN PUSHORT Port)
+RtlIpv6StringToAddressExW(IN PWCHAR AddressName,
+                          OUT struct in6_addr *Address,
+                          OUT PULONG ScopeId,
+                          OUT PUSHORT Port)
 {
     UNIMPLEMENTED;
     return STATUS_NOT_IMPLEMENTED;
Index: lib/rtl/thread.c
===================================================================
--- lib/rtl/thread.c	(revision 21808)
+++ lib/rtl/thread.c	(working copy)
@@ -12,6 +12,7 @@
 /* INCLUDES *****************************************************************/
 
 #include <rtl.h>
+#include "i386/ketypes.h"
 
 #define NDEBUG
 #include <debug.h>
Index: lib/rtl/path.c
===================================================================
--- lib/rtl/path.c	(revision 21808)
+++ lib/rtl/path.c	(working copy)
@@ -61,29 +61,29 @@
 
    if (Path == NULL)
    {
-      return INVALID_PATH;
+      return RtlPathTypeUnknown;
    }
 
    if (IS_PATH_SEPARATOR(Path[0]))
    {
-      if (!IS_PATH_SEPARATOR(Path[1])) return ABSOLUTE_PATH;         /* \xxx   */
-      if (Path[2] != L'.') return UNC_PATH;                          /* \\xxx   */
-      if (IS_PATH_SEPARATOR(Path[3])) return DEVICE_PATH;            /* \\.\xxx */
-      if (Path[3]) return UNC_PATH;                                  /* \\.xxxx */
+      if (!IS_PATH_SEPARATOR(Path[1])) return RtlPathTypeRooted;         /* \xxx   */
+      if (Path[2] != L'.') return RtlPathTypeUncAbsolute;                          /* \\xxx   */
+      if (IS_PATH_SEPARATOR(Path[3])) return RtlPathTypeLocalDevice;            /* \\.\xxx */
+      if (Path[3]) return RtlPathTypeUncAbsolute;                                  /* \\.xxxx */
 
-      return UNC_DOT_PATH;                                           /* \\.     */
+      return RtlPathTypeRootLocalDevice;                                           /* \\.     */
    }
    else
    {
       /* FIXME: the Wine version of this line reads:
-       * if (!Path[1] || Path[1] != L':')    return RELATIVE_PATH
+       * if (!Path[1] || Path[1] != L':')    return RtlPathTypeRelative
        * Should we do this too?
        * -Gunnar
        */
-      if (Path[1] != L':') return RELATIVE_PATH;                     /* xxx     */
-      if (IS_PATH_SEPARATOR(Path[2])) return ABSOLUTE_DRIVE_PATH;    /* x:\xxx  */
+      if (Path[1] != L':') return RtlPathTypeRelative;                     /* xxx     */
+      if (IS_PATH_SEPARATOR(Path[2])) return RtlPathTypeDriveAbsolute;    /* x:\xxx  */
 
-      return RELATIVE_DRIVE_PATH;                                    /* x:xxx   */
+      return RtlPathTypeDriveRelative;                                    /* x:xxx   */
    }
 }
 
@@ -448,16 +448,16 @@
 
     switch (type = RtlDetermineDosPathNameType_U(name))
     {
-    case UNC_PATH:              /* \\foo   */
+    case RtlPathTypeUncAbsolute:              /* \\foo   */
         ptr = skip_unc_prefix( name );
         mark = (ptr - name);
         break;
 
-    case DEVICE_PATH:           /* \\.\foo */
+    case RtlPathTypeLocalDevice:           /* \\.\foo */
         mark = 4;
         break;
 
-    case ABSOLUTE_DRIVE_PATH:   /* c:\foo  */
+    case RtlPathTypeDriveAbsolute:   /* c:\foo  */
         reqsize = sizeof(WCHAR);
         tmp[0] = towupper(name[0]);
         ins_str = tmp;
@@ -465,7 +465,7 @@
         mark = 3;
         break;
 
-    case RELATIVE_DRIVE_PATH:   /* c:foo   */
+    case RtlPathTypeDriveRelative:   /* c:foo   */
         dep = 2;
         if (towupper(name[0]) != towupper(cd->Buffer[0]) || cd->Buffer[1] != ':')
         {
@@ -517,7 +517,7 @@
         }
         /* fall through */
 
-    case RELATIVE_PATH:         /* foo     */
+    case RtlPathTypeRelative:         /* foo     */
         reqsize = cd->Length;
         ins_str = cd->Buffer;
         if (cd->Buffer[1] != ':')
@@ -528,7 +528,7 @@
         else mark = 3;
         break;
 
-    case ABSOLUTE_PATH:         /* \xxx    */
+    case RtlPathTypeRooted:         /* \xxx    */
 #ifdef __WINE__
         if (name[0] == '/')  /* may be a Unix path */
         {
@@ -564,7 +564,7 @@
         }
         break;
 
-    case UNC_DOT_PATH:         /* \\.     */
+    case RtlPathTypeRootLocalDevice:         /* \\.     */
         reqsize = 4 * sizeof(WCHAR);
         dep = 3;
         tmp[0] = '\\';
@@ -575,7 +575,7 @@
         mark = 4;
         break;
 
-    case INVALID_PATH:
+    case RtlPathTypeUnknown:
         goto done;
     }
 
@@ -794,8 +794,8 @@
 	Length = wcslen(fullname + Offset);
 	memcpy (Buffer + tmpLength, fullname + Offset, (Length + 1) * sizeof(WCHAR));
 	Length += tmpLength;
-	if (Type == ABSOLUTE_DRIVE_PATH ||
-	    Type == RELATIVE_DRIVE_PATH)
+	if (Type == RtlPathTypeDriveAbsolute ||
+	    Type == RtlPathTypeDriveRelative)
 	{
 	    /* make the drive letter to uppercase */
 	    Buffer[tmpLength] = towupper(Buffer[tmpLength]);
@@ -840,9 +840,9 @@
 ULONG
 NTAPI
 RtlDosSearchPath_U (
-	WCHAR *sp,
-	WCHAR *name,
-	WCHAR *ext,
+	PCWSTR sp,
+	PCWSTR name,
+	PCWSTR ext,
 	ULONG buf_sz,
 	WCHAR *buffer,
 	PWSTR *FilePart
@@ -852,7 +852,7 @@
 	ULONG Length = 0;
 	PWSTR full_name;
 	PWSTR wcs;
-	PWSTR path;
+	PCWSTR path;
 
 	Type = RtlDetermineDosPathNameType_U (name);
 
@@ -915,7 +915,7 @@
  * @implemented
  */
 BOOLEAN NTAPI
-RtlDoesFileExists_U(IN PWSTR FileName)
+RtlDoesFileExists_U(IN PCWSTR FileName)
 {
 	UNICODE_STRING NtFileName;
 	OBJECT_ATTRIBUTES Attr;
Index: lib/rtl/bootdata.c
===================================================================
--- lib/rtl/bootdata.c	(revision 21808)
+++ lib/rtl/bootdata.c	(working copy)
@@ -657,7 +657,7 @@
 
         /* free allocated memory */
         ASSERT(SecurityDescriptor != NULL);
-        ASSERT(SecurityDescriptor->Dacl != NULL)
+        ASSERT(SecurityDescriptor->Dacl != NULL);
 
         RtlpFreeMemory(SecurityDescriptor->Dacl,
                        TAG('S', 'e', 'A', 'c'));
Index: ntoskrnl/ldr/loader.c
===================================================================
--- ntoskrnl/ldr/loader.c	(revision 21808)
+++ ntoskrnl/ldr/loader.c	(working copy)
@@ -131,7 +131,7 @@
     DPRINT("ModuleObject:%08x  entrypoint at %x\n", &NtoskrnlModuleObject, NtoskrnlModuleObject.EntryPoint);
     NtoskrnlModuleObject.SizeOfImage = NtHeader->OptionalHeader.SizeOfImage;
 
-    InsertTailList(&ModuleListHead, &NtoskrnlModuleObject.InLoadOrderModuleList);
+    InsertTailList(&ModuleListHead, &NtoskrnlModuleObject.InLoadOrderLinks);
 
     /* Initialize ModuleObject for HAL */
     RtlZeroMemory(&HalModuleObject, sizeof(LDR_DATA_TABLE_ENTRY));
@@ -145,7 +145,7 @@
     DPRINT("ModuleObject:%08x  entrypoint at %x\n", &HalModuleObject, HalModuleObject.EntryPoint);
     HalModuleObject.SizeOfImage = NtHeader->OptionalHeader.SizeOfImage;
 
-    InsertTailList(&ModuleListHead, &HalModuleObject.InLoadOrderModuleList);
+    InsertTailList(&ModuleListHead, &HalModuleObject.InLoadOrderLinks);
 }
 
 NTSTATUS
@@ -343,7 +343,7 @@
 
     /* Remove the module from the module list */
     KeAcquireSpinLock(&ModuleListLock,&Irql);
-    RemoveEntryList(&ModuleObject->InLoadOrderModuleList);
+    RemoveEntryList(&ModuleObject->InLoadOrderLinks);
     KeReleaseSpinLock(&ModuleListLock, Irql);
 
     /* Hook for KDB on unloading a driver. */
@@ -390,7 +390,7 @@
     PLIST_ENTRY current_entry;
     PLDR_DATA_TABLE_ENTRY current;
     ULONG ModuleCount = 0;
-    PSYSTEM_MODULE_INFORMATION Smi;
+    PRTL_PROCESS_MODULES Smi;
     ANSI_STRING AnsiName;
     PCHAR p;
     KIRQL Irql;
@@ -405,13 +405,13 @@
     while (current_entry != (&ModuleListHead))
     {
         ModuleCount++;
-        current = CONTAINING_RECORD(current_entry,LDR_DATA_TABLE_ENTRY,InLoadOrderModuleList);
+        current = CONTAINING_RECORD(current_entry,LDR_DATA_TABLE_ENTRY,InLoadOrderLinks);
         tmpBufferSize += current->FullDllName.Length + sizeof(WCHAR) + sizeof(UNICODE_STRING);
         current_entry = current_entry->Flink;
     }
 
-    *ReqSize = sizeof(SYSTEM_MODULE_INFORMATION)+
-        (ModuleCount - 1) * sizeof(SYSTEM_MODULE_INFORMATION_ENTRY);
+    *ReqSize = sizeof(RTL_PROCESS_MODULES)+
+        (ModuleCount - 1) * sizeof(RTL_PROCESS_MODULE_INFORMATION);
 
     if (Size < *ReqSize)
     {
@@ -431,23 +431,23 @@
     /* fill the buffer */
     memset(Buffer, '=', Size);
 
-    Smi = (PSYSTEM_MODULE_INFORMATION)Buffer;
-    Smi->Count = ModuleCount;
+    Smi = (PRTL_PROCESS_MODULES)Buffer;
+    Smi->NumberOfModules = ModuleCount;
 
     ModuleCount = 0;
     current_entry = ModuleListHead.Flink;
     while (current_entry != (&ModuleListHead))
     {
-        current = CONTAINING_RECORD(current_entry,LDR_DATA_TABLE_ENTRY,InLoadOrderModuleList);
+        current = CONTAINING_RECORD(current_entry,LDR_DATA_TABLE_ENTRY,InLoadOrderLinks);
 
-        Smi->Module[ModuleCount].Unknown1 = 0;                /* Always 0 */
-        Smi->Module[ModuleCount].Unknown2 = 0;                /* Always 0 */
-        Smi->Module[ModuleCount].Base = current->DllBase;
-        Smi->Module[ModuleCount].Size = current->SizeOfImage;
-        Smi->Module[ModuleCount].Flags = 0;                /* Flags ??? (GN) */
-        Smi->Module[ModuleCount].Index = (USHORT)ModuleCount;
-        Smi->Module[ModuleCount].NameLength = 0;
-        Smi->Module[ModuleCount].LoadCount = 0; /* FIXME */
+        Smi->Modules[ModuleCount].Section = 0;                /* Always 0 */
+        Smi->Modules[ModuleCount].MappedBase = 0;                /* Always 0 */
+        Smi->Modules[ModuleCount].ImageBase = current->DllBase;
+        Smi->Modules[ModuleCount].ImageSize = current->SizeOfImage;
+        Smi->Modules[ModuleCount].Flags = 0;                /* Flags ??? (GN) */
+        Smi->Modules[ModuleCount].LoadOrderIndex = (USHORT)ModuleCount;
+        Smi->Modules[ModuleCount].InitOrderIndex = 0;
+        Smi->Modules[ModuleCount].LoadCount = 0; /* FIXME */
         UnicodeName[ModuleCount].Buffer = tmpNameBuffer;
         UnicodeName[ModuleCount].MaximumLength = current->FullDllName.Length + sizeof(WCHAR);
         tmpNameBuffer += UnicodeName[ModuleCount].MaximumLength / sizeof(WCHAR);
@@ -459,24 +459,24 @@
 
     KeReleaseSpinLock(&ModuleListLock, Irql);
 
-    for (ModuleCount = 0; ModuleCount < Smi->Count; ModuleCount++)
+    for (ModuleCount = 0; ModuleCount < Smi->NumberOfModules; ModuleCount++)
     {
         AnsiName.Length = 0;
         AnsiName.MaximumLength = 255;
-        AnsiName.Buffer = Smi->Module[ModuleCount].ImageName;
+        AnsiName.Buffer = Smi->Modules[ModuleCount].FullPathName;
         RtlUnicodeStringToAnsiString(&AnsiName, &UnicodeName[ModuleCount], FALSE);
         AnsiName.Buffer[AnsiName.Length] = 0;
-        Smi->Module[ModuleCount].NameLength = AnsiName.Length;
+        Smi->Modules[ModuleCount].InitOrderIndex = AnsiName.Length;
 
         p = strrchr(AnsiName.Buffer, '\\');
         if (p == NULL)
         {
-            Smi->Module[ModuleCount].PathLength = 0;
+            Smi->Modules[ModuleCount].OffsetToFileName = 0;
         }
         else
         {
             p++;
-            Smi->Module[ModuleCount].PathLength = p - AnsiName.Buffer;
+            Smi->Modules[ModuleCount].OffsetToFileName = p - AnsiName.Buffer;
         }
     }
 
@@ -596,7 +596,7 @@
     Entry = ModuleListHead.Flink;
     while (Entry != &ModuleListHead)
     {
-        Module = CONTAINING_RECORD(Entry, LDR_DATA_TABLE_ENTRY, InLoadOrderModuleList);
+        Module = CONTAINING_RECORD(Entry, LDR_DATA_TABLE_ENTRY, InLoadOrderLinks);
 
         DPRINT("Comparing %wZ and %wZ\n",
             &Module->BaseDllName,
@@ -897,7 +897,7 @@
     /* Insert module */
     KeAcquireSpinLock(&ModuleListLock, &Irql);
     InsertTailList(&ModuleListHead,
-        &CreatedModuleObject->InLoadOrderModuleList);
+        &CreatedModuleObject->InLoadOrderLinks);
     KeReleaseSpinLock(&ModuleListLock, Irql);
 
     *ModuleObject = CreatedModuleObject;
